require 'net/http'
require 'net/ping'
module ProxyUtilities
  class Checker

    def initialize(ip, port)
      @ip = ip
      @port = port
    end

    def check_online?
      begin
        check = Net::Ping::External.new(host = @ip, port = @port)
        check.ping?
      rescue
        return false
      end
    end

    def check_google?
      begin
        url = "http://google.com"
        proxy_connection = Net::HTTP::Proxy(@ip, @port.to_i)
        Timeout.timeout(3) do
          return proxy_connection.start(url).active?
        end
      rescue
        return false
      end
    end

    def check_amazon?
      begin
        url = "http://amazon.com"
        proxy_connection = Net::HTTP::Proxy(@ip, @port.to_i)
        Timeout.timeout(3) do
          return proxy_connection.start(url).active?
        end
      rescue
        return false
      end
    end

    def check_any_website(websites)
      result = {}
      proxy_connection = Net::HTTP::Proxy(@ip, @port.to_i)
      websites.each do |website|
        begin
          Timeout.timeout(3) do
            result[website] = proxy_connection.start(website).active?
          end
        rescue
          next
        end
      end
      return result
    end
  end
end
